//---------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMmanualResetEvent class
//
// Description:
//
// Implementation
//
// Author: Steven Dodd
// Date:   Jan 28, 2009
//
//---------------------------------------------------------------------------
#include "CHMpreCompHead.h"
#pragma hdrstop

#ifdef CHM_NO_PRECOMPILED_HEADERS
#  include <CHM/CHMevent.h>
#  include <CHM/CHMmanualResetEventClass.h>
#endif

CHMmanualResetEvent::CHMmanualResetEvent()
:
   EventHandle(0)
{
   CHM_CHECK_CALL( CHMeventCreate( &EventHandle, true ) );
}

CHMmanualResetEvent::~CHMmanualResetEvent()
{
   try
   {
      CHM_CHECK_CALL( CHMeventDestroy(EventHandle) );
   }
   catch (...)
   {
   }
}

void CHMmanualResetEvent::reset()
{
   CHM_CHECK_CALL( CHMeventReset(EventHandle) );
}

void CHMmanualResetEvent::signal()
{
   CHM_CHECK_CALL( CHMeventSignal(EventHandle) );
}

void CHMmanualResetEvent::wait()
{
   CHM_CHECK_CALL( CHMeventWait(EventHandle) );
}

CHMboolean CHMmanualResetEvent::wait( CHMuint32 TimeoutInMilliseconds )
{
   CHMboolean Signalled = false;
   CHM_CHECK_CALL( CHMeventWaitWithTimeout(EventHandle, TimeoutInMilliseconds, &Signalled) );
   return Signalled;
}
